import jwt from 'jsonwebtoken'
import { createError } from './error.js'

/**verifyToken() Business Logic:
 * Check if there's a token generated by login in authController.
 * If none, return error.
 * If there's a token, verify it with jwt.verify().
 * If token is not valid, return error.
 * If token is valid, save the payload in req.anyVariable
 * and allow to move next
 */
export const verifyToken = (req, res, next) => {
  //get cookies generated by login in authController
  const token = req.cookies.access_token

  //if their is no cookies, send error and exit
  if (!token) return next(createError(401, 'You are not logged in!'))

  //if their is a cookies, verify and return error or its payload
  jwt.verify(token, process.env.JWT_SECRET, (err, payload) => {
    if (err) return next(createError(403, 'Invalid token!'))

    //if token is valid create & save to new property in req
    req.user = payload

    //allow to move to next function
    next()
  })
}

/**Business Logic:
 * Verify 1st the token - use verifyToken()
 * If it has passed the token verification,
 * compare the temporary variable req.anyVar against params.
 * If req.user.id is the same with req.params.id or req.user.isAdmin is true
 * allow to move next
 */

//next() below should be from verifyUser or you will be directed
//to next function once you passed the verifyToken

export const verifyUser = (req, res, next) => {
  verifyToken(req, res, () => {
    //req.user is from verifyToken where we save the payload
    if (req?.user?.id === undefined) {
      return next(createError(401, 'You are not logged in!'))
    } else if (req?.user?.id === req.params.id || req?.user?.isAdmin) {
      next()
    } else {
      return next(createError(403, 'You are not authorized!'))
    }
  })
}

/**
 * NOT REQUIRED BUT JUST IN CASE NEEDED IN THE FUTURE
 * Business Logic:
 * Verify if there is a valid token using verifyToken()
 * Check value of isAdmin
 * Move next if it is true
 * Send appropriate errors if not true
 */
export const verifyAdmin = (req, res, next) => {
  verifyToken(req, res, () => {
    const isAdmin = req?.user?.isAdmin

    switch (isAdmin) {
      case undefined:
        return next(createError(401, 'You are not logged in!'))
        break

      case true:
        next()
        break

      case false:
        return next(createError(403, 'You are not an admin!'))
        break

      default:
        return next(createError(403, 'Something went wrong!'))
        break
    }
  })
}
